# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   ${PROJECT_NAME}
# FileName:      ${FILE_NAME}
# Author:        shen
# Datetime:     ${DATE} ${TIME}
# Description:
#
# ---------------------------------------------------------------------------
import pymysql

from APIAutoTest_shen_2 import log_decorator
from APIAutoTest_shen_2.common.read_basic_ini import ReadBasicIni


class DB:
    @log_decorator
    def __init__(self):
        """连接数据库，获取连接对象和游标对象"""
        # 创建ReadBasicIni对象
        ini = ReadBasicIni()
        #创建连接对象
        self.conn = pymysql.connect(
            host=ini.get_database_conn_msg("host"),
            port=int(ini.get_database_conn_msg("port")),
            user=ini.get_database_conn_msg("user"),
            password=ini.get_database_conn_msg("pwd"),
            database=ini.get_database_conn_msg("database"),
            charset="utf8"
        )
        #创建游标对象
        self.cursor = self.conn.cursor()
    @log_decorator
    def close(self):
        """关闭连接对象和游标对象"""
        #先关闭游标对象再关闭连接对象
        self.cursor.close()
        self.conn.close()

    @log_decorator
    def delete(self,sql_data):
        """执行sql的删除语句"""
        #执行删除语句
        self.cursor.execute(sql_data)
        #连接对象提交
        self.conn.commit()
    @log_decorator
    def select(self,sql_data):
        """执行sql的查询语句"""
        #执行查询语句
        self.cursor.execute(sql_data)
        #获取查询结果并返回
        select_res = self.cursor.fetchall()
        #判断是否有查询结果，有就返回第一个结果，没有就返回none
        if select_res:
            return select_res[0][0]


if __name__ == '__main__':
    db = DB()
    sql = """DELETE  FROM uc_demension where CODE_ = "test_dem";"""
    sql1 = """select ID_ from uc_demension where CODE_="test_dem1";"""
    print(db.select(sql1))















